package com.seeyon.apps.doc.util;

import com.seeyon.apps.doc.po.DocActionUserPO;
import com.seeyon.apps.doc.po.DocResourcePO;
import com.seeyon.apps.doc.util.KnowledgeUtils;
import com.seeyon.apps.doc.vo.DocCollectTopVO;
import com.seeyon.ctp.organization.bo.V3xOrgEntity;
import com.seeyon.ctp.organization.manager.OrgManager;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class DocActionUtils {

   private static final Log log = LogFactory.getLog(DocActionUtils.class);


   public static String getSqlByParam(Map param) {
      StringBuilder hql = new StringBuilder();
      if(param != null && !param.isEmpty()) {
         if(param.containsKey("actionUserId") && param.get("actionUserId") != null) {
            hql.append(" and t.actionUserId = :actionUserId");
         }

         if(param.containsKey("actionTime") && param.get("actionTime") != null) {
            hql.append(" and t.actionTime = :actionTime");
         }

         Object type = param.get("actionType");
         if(type != null) {
            if(type instanceof String) {
               hql.append(" and t.actionType = :actionType");
            } else if(type instanceof Integer) {
               hql.append(" and t.actionType = :actionType");
            } else if(type instanceof Collection) {
               hql.append(" and t.actionType in (:actionType)");
            }
         }

         Object subjectId = param.get("subjectId");
         if(subjectId != null) {
            if(subjectId instanceof String) {
               hql.append(" and t.subjectId = :subjectId");
            } else if(subjectId instanceof Long) {
               hql.append(" and t.subjectId = :subjectId");
            } else if(subjectId instanceof Collection) {
               hql.append(" and t.subjectId in (:subjectId)");
            }
         }

         if(param.containsKey("userAccountId") && param.get("userAccountId") != null) {
            hql.append(" and t.userAccountId = :userAccountId");
         }

         if(param.containsKey("beginActionTime") && param.get("beginActionTime") != null) {
            param.put("beginActionTime", KnowledgeUtils.getFirstTime(param.get("beginActionTime")));
            hql.append(" and t.actionTime >= :beginActionTime");
         }

         if(param.containsKey("endActionTime") && param.get("endActionTime") != null) {
            param.put("beginActionTime", KnowledgeUtils.getLastTime(param.get("beginActionTime")));
            hql.append(" and t.actionTime <= :endActionTime");
         }

         if(param.containsKey("columnText") && param.get("columnText") != null) {
            hql.append(" and t.columnText = :columnText");
         }

         if(param.containsKey("columnText2") && param.get("columnText2") != null) {
            hql.append(" and t.columnText2 = :columnText2");
         }

         if(param.containsKey("docActionId") && param.get("docActionId") != null) {
            hql.append(" and t.docActionId = :docActionId");
         }

         if(param.containsKey("userId") && param.get("userId") != null) {
            hql.append(" and t.userId = :userId");
         }

         if(param.containsKey("feedBackType") && param.get("feedBackType") != null) {
            hql.append(" and t.feedBackType = :feedBackType");
         }

         if(param.containsKey("beginFeedBackTime") && param.get("beginFeedBackTime") != null) {
            param.put("beginActionTime", KnowledgeUtils.getFirstTime(param.get("beginActionTime")));
            hql.append(" and t.feedBackTime >= :beginFeedBackTime");
         }

         if(param.containsKey("endFeedBackTime") && param.get("endFeedBackTime") != null) {
            param.put("beginActionTime", KnowledgeUtils.getLastTime(param.get("beginActionTime")));
            hql.append(" and t.feedBackTime <= :endFeedBackTime");
         }

         if(param.containsKey("sort") && param.get("sort") != null) {
            hql.append(" order by :sort");
            if(param.containsKey("order") && "ASC".equalsIgnoreCase(String.valueOf(param.get("order")))) {
               hql.append(" ASC");
            } else {
               hql.append(" DESC");
            }
         }
      }

      return hql.toString();
   }

   public static List beansToBeans(List from, Class to) {
      ArrayList rt = new ArrayList();
      Iterator var3 = from.iterator();

      while(var3.hasNext()) {
         Object item = var3.next();
         rt.add(beanToBean(item, to));
      }

      return rt;
   }

   public static Object beanToBean(Object fromBean, Class to) {
      Object toBean = null;

      try {
         toBean = to.newInstance();
      } catch (Exception var13) {
         log.error("", var13);
      }

      HashMap methodMap = new HashMap();
      Class type = fromBean.getClass();
      Method[] methods = type.getMethods();
      Method[] lClass = methods;
      int method = methods.length;

      int i;
      for(i = 0; i < method; ++i) {
         Method methodName = lClass[i];
         String e = methodName.getName();
         if(e.startsWith("get") && methodName.getParameterTypes().length == 0) {
            methodMap.put(e.substring(3), methodName);
         } else if(e.startsWith("is") && methodName.getParameterTypes().length == 0) {
            methodMap.put(e.substring(2), methodName);
         }
      }

      for(Class var14 = toBean.getClass(); var14 != Object.class; var14 = var14.getSuperclass()) {
         methods = var14.getDeclaredMethods();

         for(i = 0; i < methods.length; ++i) {
            Method var15 = methods[i];
            if(var15 != null && var15.getModifiers() == 1) {
               String var16 = var15.getName();

               try {
                  Method var17 = (Method)methodMap.get(var16.substring(3));
                  if(var16.startsWith("set") && var17 != null) {
                     Object valueObj = var17.invoke(fromBean, new Object[0]);
                     if(valueObj != null) {
                        var15.invoke(toBean, new Object[]{valueObj});
                     }
                  }
               } catch (Exception var12) {
                  log.error("", var12);
               }
            }
         }
      }

      return toBean;
   }

   public static void main(String[] arg) {
      ArrayList l = new ArrayList();
      DocResourcePO doc = new DocResourcePO();
      doc.setFrName("12");
      l.add(doc);
      doc = new DocResourcePO();
      doc.setFrName("34");
      l.add(doc);
      List l2 = beansToBeans(l, DocCollectTopVO.class);
   }

   public static Map getStrNameFromOrg(List dups, Long userId, OrgManager orgManager, int limtSize) {
      HashMap retMap = new HashMap();

      try {
         String e = "、";
         String recommendederAll = "";

         for(int recommendeders = 0; recommendeders < dups.size(); ++recommendeders) {
            DocActionUserPO recommendeder = (DocActionUserPO)dups.get(recommendeders);
            Object ve = orgManager.getEntityOnlyById(recommendeder.getUserId());
            if(ve == null) {
               ve = orgManager.getMemberById(recommendeder.getUserId());
            }

            if(ve != null) {
               recommendederAll = recommendederAll + ((V3xOrgEntity)ve).getName() + e;
            }
         }

         String[] var14 = recommendederAll.split(e);
         String var15 = "";
         String[] var16 = var14;
         int var10 = var14.length;

         for(int var11 = 0; var11 < var10; ++var11) {
            String remd = var16[var11];
            var15 = var15 + remd + e;
            if(var15.length() > limtSize) {
               var15 = var15.substring(0, var15.length() - 1);
               var15 = var15 + "...";
               break;
            }
         }

         if(var15.endsWith(e)) {
            var15 = var15.substring(0, var15.length() - 1);
         }

         if(recommendederAll.endsWith(e)) {
            recommendederAll = recommendederAll.substring(0, recommendederAll.length() - 1);
         }

         if(var15.endsWith(e)) {
            var15 = var15.substring(0, var15.length() - 1);
         }

         if(recommendederAll.endsWith(e)) {
            recommendederAll = recommendederAll.substring(0, recommendederAll.length() - 1);
         }

         retMap.put("recommendeder", var15);
         retMap.put("recommendederAll", recommendederAll);
         return retMap;
      } catch (Exception var13) {
         log.error("", var13);
         return retMap;
      }
   }

}
